#!/usr/bin/perl -w
use Test;
BEGIN { plan tests => 5 }
BEGIN { unshift @INC, "../blib/lib" } 
use POWER::lib qw(sleep);
use POWER::SQL;
use DBI;
$dbh = DBI->connect("dbi:mysql:test","test","",{RaiseError=>1});

$table_date = "POWER_SQL_test_date_$$";
$dbh->do("CREATE TABLE $table_date (id int auto_increment primary key,
    _cdate datetime NOT NULL, _mdate datetime NOT NULL)");
END { $dbh->do("DROP TABLE $table_date") }

$NOW = $dbh->Col("SELECT NOW()");
$dbh->Insert($table_date, {id=>undef});
sleep 1.1;
$dbh->Insert($table_date, {id=>undef});
sleep 1.1;
$dbh->Insert($table_date, {id=>undef});
sleep 1.1;
$dbh->Insert($table_date, {id=>undef});
sleep 1.1;
$dbh->Update($table_date, {id=>2,id__eq=>2});
$dbh->Update($table_date, {id=>30,id__eq=>3}); #   , . BUGS
sleep 1.1;
$dbh->Replace($table_date, {id=>4});


@test_date = (
    "SELECT 1 FROM $table_date WHERE _cdate IS NULL OR
     _mdate IS NULL OR _cdate < '$NOW' OR _mdate < '$NOW'"	    => [],
    "SELECT 1 FROM $table_date WHERE id=1 AND _cdate = _mdate"	    => [1],
    "SELECT 1 FROM $table_date WHERE id=2 AND _cdate < _mdate"	    => [1],
    "SELECT 1 FROM $table_date WHERE id=3 AND _cdate = _mdate"	    => [1],
    "SELECT 1 FROM $table_date t1, $table_date t2 WHERE t1.id=2 AND
     t2.id=4 AND t1._mdate < t2._cdate AND t1._mdate < t2._mdate"   => [1],
    );

while (@test_date) {
    ($test, $wait) = (shift @test_date, shift @test_date);
    @res = $dbh->Col($test);
    ok(Diff(\@res, $wait), 1, $test);
}

